## gnu-efi 3.0a

=== Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
# This file is part of the gnu-efi package.
#
#  GNU-EFI is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
#
#  GNU-EFI is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with GNU-EFI; see the file COPYING.  If not, write to the Free
#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
#

include Make.defaults

SUBDIRS = lib gnuefi inc apps

all:	$(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@

clean:
	rm -f *~
	@for d in $(SUBDIRS); do $(MAKE) -C $$d clean; done

install:
	@for d in $(SUBDIRS); do $(MAKE) -C $$d install; done

.PHONY:	$(SUBDIRS) clean depend

include Make.rules

## gnu-efi 3.0d

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 SUBDIRS = lib gnuefi inc apps
 
-all:	$(SUBDIRS)
+all:	check_gcc $(SUBDIRS)
 
 $(SUBDIRS):
 	$(MAKE) -C $@
@@ -39,4 +39,13 @@
 
 .PHONY:	$(SUBDIRS) clean depend
 
+#
+# on both platforms you must use gcc 3.0 or higher 
+#
+check_gcc:
+ifeq ($(GCC_VERSION),2)
+	@echo "you need to use a version of gcc >= 3.0, you are using `$(CC) --version`"
+	@exit 1
+endif
+
 include Make.rules

=== gnuefi/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
# This file is part of the gnu-efi package.
#
#  GNU-EFI is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
#
#  GNU-EFI is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with GNU-EFI; see the file COPYING.  If not, write to the Free
#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
#

include ../Make.defaults
CDIR=$(TOPDIR)/..
FILES	= reloc_$(ARCH)

OBJS	= $(FILES:%=%.o)

TARGETS	= crt0-efi-$(ARCH).o libgnuefi.a

all:	$(TARGETS)

libgnuefi.a: libgnuefi.a($(OBJS))

clean:
	rm -f $(TARGETS) *~ *.o $(OBJS)

install:
	mkdir -p $(INSTALLROOT)/lib
	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)/lib
	$(INSTALL) -m 644 elf_$(ARCH)_efi.lds $(INSTALLROOT)/lib

include ../Make.rules

=== inc/Makefile ===
include ../Make.defaults

CDIR=$(TOPDIR)/..

all:

clean:

install:
	mkdir -p $(INSTALLROOT)/include/efi
	mkdir -p $(INSTALLROOT)/include/efi/protocol
	mkdir -p $(INSTALLROOT)/include/efi/$(ARCH)
	$(INSTALL) -m 644 *.h $(INSTALLROOT)/include/efi
	$(INSTALL) -m 644 protocol/*.h $(INSTALLROOT)/include/efi/protocol
	$(INSTALL) -m 644 $(ARCH)/*.h $(INSTALLROOT)/include/efi/$(ARCH)
ifeq ($(ARCH),ia64)
	mkdir -p $(INSTALLROOT)/include/efi/protocol/ia64
	$(INSTALL) -m 644 protocol/ia64/*.h $(INSTALLROOT)/include/efi/protocol/ia64
endif

include ../Make.rules

## gnu-efi 3.0e

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#  Copyright (C) 1999-2001 Hewlett-Packard Co.
+#  Copyright (C) 1999-2007 Hewlett-Packard Co.
 #	Contributed by David Mosberger <davidm@hpl.hp.com>
 #	Contributed by Stephane Eranian <eranian@hpl.hp.com>
 #

=== lib/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
# This file is part of the gnu-efi package.
#
#  GNU-EFI is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
#
#  GNU-EFI is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with GNU-EFI; see the file COPYING.  If not, write to the Free
#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
#

include ../Make.defaults
CDIR = $(TOPDIR)/..
FILES = boxdraw smbios console crc data debug dpath  \
        error event guid hand hw init lock   \
        misc print sread str \
	runtime/rtlock runtime/efirtlib runtime/rtstr runtime/vm runtime/rtdata  \
	$(ARCH)/initplat $(ARCH)/math 

ifeq ($(ARCH),ia64)
FILES += $(ARCH)/salpal $(ARCH)/palproc
endif

ifeq ($(ARCH),x86_64)
FILES += $(ARCH)/callwrap $(ARCH)/efi_stub
endif

OBJS  = $(FILES:%=%.o)

libefi.a: libefi.a($(OBJS))

clean:
	rm -f libefi.a *~ $(OBJS) */*.o

install: libefi.a
	mkdir -p $(INSTALLROOT)/lib
	$(INSTALL) -m 644 libefi.a $(INSTALLROOT)/lib/

include ../Make.rules

## gnu-efi 3.0i

=== Makefile ===
--- 
+++ 
@@ -21,14 +21,19 @@
 #  02111-1307, USA.
 #
 
-include Make.defaults
+SRCDIR = .
+
+VPATH = $(SRCDIR)
+
+include $(SRCDIR)/Make.defaults
 
 SUBDIRS = lib gnuefi inc apps
 
 all:	check_gcc $(SUBDIRS)
 
 $(SUBDIRS):
-	$(MAKE) -C $@
+	mkdir -p $@
+	$(MAKE) -C $@ -f $(SRCDIR)/../$@/Makefile SRCDIR=$(SRCDIR)/../$@ ARCH=$(ARCH)
 
 clean:
 	rm -f *~
@@ -48,4 +53,4 @@
 	@exit 1
 endif
 
-include Make.rules
+include $(SRCDIR)/Make.rules

=== apps/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
# This file is part of the gnu-efi package.
#
#  GNU-EFI is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
#
#  GNU-EFI is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with GNU-EFI; see the file COPYING.  If not, write to the Free
#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
#

SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR=$(TOPDIR)/..
LINUX_HEADERS	= /usr/src/sys/build
CPPFLAGS	+= -D__KERNEL__ -I$(LINUX_HEADERS)/include
CRTOBJS		= ../gnuefi/crt0-efi-$(ARCH).o

LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_efi.lds
ifeq ($(ARCH),x86_64)
 ifneq (,$(findstring FreeBSD,$(OS)))
LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_fbsd_efi.lds
 endif
endif

LDFLAGS		+= -T $(LDSCRIPT) -shared -Bsymbolic -L../lib -L../gnuefi $(CRTOBJS)
LOADLIBES	= -lefi -lgnuefi $(shell $(CC) $(ARCH3264) -print-libgcc-file-name)
FORMAT		= efi-app-$(ARCH)

TARGETS = t.efi t2.efi t3.efi t4.efi t5.efi t6.efi printenv.efi t7.efi

all:	$(TARGETS)

clean:
	rm -f $(TARGETS) *~ *.o *.so

.PHONY: install

include $(SRCDIR)/../Make.rules

=== gnuefi/Makefile ===
--- 
+++ 
@@ -21,9 +21,16 @@
 #  02111-1307, USA.
 #
 
-include ../Make.defaults
+SRCDIR = .
+
+VPATH = $(SRCDIR)
+
+include $(SRCDIR)/../Make.defaults
+
+TOPDIR = $(SRCDIR)/..
+
 CDIR=$(TOPDIR)/..
-FILES	= reloc_$(ARCH)
+FILES	= reloc_$(ARCH) setjmp_$(ARCH)
 
 OBJS	= $(FILES:%=%.o)
 
@@ -37,8 +44,16 @@
 	rm -f $(TARGETS) *~ *.o $(OBJS)
 
 install:
-	mkdir -p $(INSTALLROOT)/lib
-	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)/lib
-	$(INSTALL) -m 644 elf_$(ARCH)_efi.lds $(INSTALLROOT)/lib
+	mkdir -p $(INSTALLROOT)/$(LIBDIR)
+	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)/$(LIBDIR)
+ifneq (,$(findstring FreeBSD,$(OS)))
+ ifeq ($(ARCH),x86_64)
+	$(INSTALL) -m 644 elf_$(ARCH)_fbsd_efi.lds $(INSTALLROOT)/$(LIBDIR)
+ else
+	$(INSTALL) -m 644 elf_$(ARCH)_efi.lds $(INSTALLROOT)/$(LIBDIR)
+ endif
+else
+	$(INSTALL) -m 644 elf_$(ARCH)_efi.lds $(INSTALLROOT)/$(LIBDIR)
+endif
 
-include ../Make.rules
+include $(SRCDIR)/../Make.rules

=== lib/Makefile ===
--- 
+++ 
@@ -21,7 +21,14 @@
 #  02111-1307, USA.
 #
 
-include ../Make.defaults
+SRCDIR = .
+
+VPATH = $(SRCDIR)
+
+include $(SRCDIR)/../Make.defaults
+
+TOPDIR = $(SRCDIR)/..
+
 CDIR = $(TOPDIR)/..
 FILES = boxdraw smbios console crc data debug dpath  \
         error event guid hand hw init lock   \
@@ -39,13 +46,22 @@
 
 OBJS  = $(FILES:%=%.o)
 
+SUBDIRS = ia32 x86_64 ia64 runtime
+
+all: libsubdirs libefi.a
+
+libsubdirs:
+	for sdir in $(SUBDIRS); do mkdir -p $$sdir; done
+
 libefi.a: libefi.a($(OBJS))
 
 clean:
 	rm -f libefi.a *~ $(OBJS) */*.o
 
 install: libefi.a
-	mkdir -p $(INSTALLROOT)/lib
-	$(INSTALL) -m 644 libefi.a $(INSTALLROOT)/lib/
+	mkdir -p $(INSTALLROOT)/$(LIBDIR)
+	$(INSTALL) -m 644 libefi.a $(INSTALLROOT)/$(LIBDIR)
 
-include ../Make.rules
+include $(SRCDIR)/../Make.rules
+
+.PHONY: libsubdirs

## gnu-efi 3.0s

=== Makefile ===
#
#  Copyright (C) 1999-2007 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/Make.defaults

SUBDIRS = lib gnuefi inc apps
gnuefi: lib

all:	check_gcc $(SUBDIRS)

$(SUBDIRS):
	mkdir -p $@
	$(MAKE) -C $@ -f $(SRCDIR)/../$@/Makefile SRCDIR=$(SRCDIR)/../$@ ARCH=$(ARCH)

clean:
	rm -f *~
	@for d in $(SUBDIRS); do $(MAKE) -C $$d clean; done

install:
	@for d in $(SUBDIRS); do $(MAKE) -C $$d install; done

.PHONY:	$(SUBDIRS) clean depend

#
# on both platforms you must use gcc 3.0 or higher 
#
check_gcc:
ifeq ($(GCC_VERSION),2)
	@echo "you need to use a version of gcc >= 3.0, you are using `$(CC) --version`"
	@exit 1
endif

include $(SRCDIR)/Make.rules

=== apps/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR=$(TOPDIR)/..
LINUX_HEADERS	= /usr/src/sys/build
CPPFLAGS	+= -D__KERNEL__ -I$(LINUX_HEADERS)/include
CRTOBJS		= ../gnuefi/crt0-efi-$(ARCH).o

LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_efi.lds
ifeq ($(ARCH),x86_64)
 ifneq (,$(findstring FreeBSD,$(OS)))
LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_fbsd_efi.lds
 endif
endif

LDFLAGS		+= -T $(LDSCRIPT) -shared -Bsymbolic -L../lib -L../gnuefi $(CRTOBJS)
LOADLIBES	= -lefi -lgnuefi $(shell $(CC) $(ARCH3264) -print-libgcc-file-name)
FORMAT		= efi-app-$(ARCH)

TARGETS = t.efi t2.efi t3.efi t4.efi t5.efi t6.efi printenv.efi t7.efi tcc.efi

all:	$(TARGETS)

clean:
	rm -f $(TARGETS) *~ *.o *.so

.PHONY: install

include $(SRCDIR)/../Make.rules

=== gnuefi/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR=$(TOPDIR)/..
FILES	= reloc_$(ARCH) setjmp_$(ARCH)

OBJS	= $(FILES:%=%.o)

TARGETS	= crt0-efi-$(ARCH).o libgnuefi.a

all:	$(TARGETS)

libgnuefi.a: libgnuefi.a($(OBJS))

clean:
	rm -f $(TARGETS) *~ *.o $(OBJS)

install:
	mkdir -p $(INSTALLROOT)/$(LIBDIR)
	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)/$(LIBDIR)
ifneq (,$(findstring FreeBSD,$(OS)))
 ifeq ($(ARCH),x86_64)
	$(INSTALL) -m 644 elf_$(ARCH)_fbsd_efi.lds $(INSTALLROOT)/$(LIBDIR)
 else
	$(INSTALL) -m 644 elf_$(ARCH)_efi.lds $(INSTALLROOT)/$(LIBDIR)
 endif
else
	$(INSTALL) -m 644 elf_$(ARCH)_efi.lds $(INSTALLROOT)/$(LIBDIR)
endif

include $(SRCDIR)/../Make.rules

=== inc/Makefile ===
--- 
+++ 
@@ -1,4 +1,10 @@
-include ../Make.defaults
+SRCDIR = .
+
+VPATH = $(SRCDIR)
+
+include $(SRCDIR)/../Make.defaults
+
+TOPDIR = $(SRCDIR)/..
 
 CDIR=$(TOPDIR)/..
 
@@ -18,4 +24,4 @@
 	$(INSTALL) -m 644 protocol/ia64/*.h $(INSTALLROOT)/include/efi/protocol/ia64
 endif
 
-include ../Make.rules
+include $(SRCDIR)/../Make.rules

=== lib/Makefile ===
--- 
+++ 
@@ -3,22 +3,35 @@
 #	Contributed by David Mosberger <davidm@hpl.hp.com>
 #	Contributed by Stephane Eranian <eranian@hpl.hp.com>
 #
-# This file is part of the gnu-efi package.
+#    All rights reserved.
 #
-#  GNU-EFI is free software; you can redistribute it and/or modify
-#  it under the terms of the GNU General Public License as published by
-#  the Free Software Foundation; either version 2, or (at your option)
-#  any later version.
+#    Redistribution and use in source and binary forms, with or without
+#    modification, are permitted provided that the following conditions
+#    are met:
 #
-#  GNU-EFI is distributed in the hope that it will be useful,
-#  but WITHOUT ANY WARRANTY; without even the implied warranty of
-#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#  GNU General Public License for more details.
+#    * Redistributions of source code must retain the above copyright
+#      notice, this list of conditions and the following disclaimer.
+#    * Redistributions in binary form must reproduce the above
+#      copyright notice, this list of conditions and the following
+#      disclaimer in the documentation and/or other materials
+#      provided with the distribution.
+#    * Neither the name of Hewlett-Packard Co. nor the names of its
+#      contributors may be used to endorse or promote products derived
+#      from this software without specific prior written permission.
 #
-#  You should have received a copy of the GNU General Public License
-#  along with GNU-EFI; see the file COPYING.  If not, write to the Free
-#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
-#  02111-1307, USA.
+#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
+#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
+#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
+#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
+#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
+#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
+#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+#    SUCH DAMAGE.
 #
 
 SRCDIR = .

## gnu-efi 3.0s+debian

=== debian/changelog ===
gnu-efi (3.0s+debian-1ubuntu2) raring; urgency=low

  * Restore -fno-stack-protector; this is needed to build packages linked
    against gnu-efi, such as efilinux.  This change is now in a patch with a
    header explaining the reasoning, to try to avoid it being dropped in
    future.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 09 Jan 2013 11:58:51 +0000

gnu-efi (3.0s+debian-1ubuntu1) raring; urgency=low

  * Merge from Debian unstable, dropped changes:
    - gnuefi/elf_x86_64_efi.lds: align the .reloc section; merged upstream.
    - Build with -fno-stack-protector; no longer needed.
  * debian/rules: past architecture arguments when building the x86_64 code on
    i386; otherwise the upstream build system wrongly assumes that if uname
    says x86_64, it doesn't have to pass -m64 to the compiler.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 12 Dec 2012 18:00:52 -0800

gnu-efi (3.0s+debian-1) unstable; urgency=low

  * Merging upstream version 3.0s+debian.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Tue, 11 Dec 2012 07:19:59 +0100

gnu-efi (3.0r+debian-1) experimental; urgency=low

  * Merging upstream version 3.0r+debian (Closes: #637276, #679627):
    - Rebuilding upstream tarball without debian directory.
  * Removing useless whitespaces at EOL and EOF.
  * Updating package to debhelper version 9.
  * Updating package to standards version 3.9.4.
  * Making build-depends on binutils unversioned, already fulfilled by
    wheezy.
  * Sorting architectures in gcc-multilib build-depends alphabetically.
  * Wrapping build-depends to 80 chars per line.
  * Adding homepage field.
  * Sorting architectures field alphabetically.
  * Removing pre-wheezy conflicts on libc6-i386.
  * Removing French spacing in package long-description.
  * Rewriting copyright file in copyright-format version 1.0.
  * Prefixing debhelper files with package name.
  * Simplifying debhelper docs file by using wildcard.
  * Removing watch file.
  * Reorganizing rules file in minimized debhelper form.
  * Switching to source format 3.0 (quilt).
  * Switching to xz compression.
  * Adding todo file.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Tue, 25 Sep 2012 09:07:00 +0200

gnu-efi (3.0i-4) unstable; urgency=low

  * Updating maintainers and uploaders fields:
    - Removing Julien from uploaders, he resigned from the project
      (Closes: #688546).
    - Removing Bdale from uploaders as he wished.
    - Adding myself as maintainer.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Tue, 25 Sep 2012 08:14:53 +0200

gnu-efi (3.0i-3ubuntu2) quantal; urgency=low

  * gnuefi/elf_x86_64_efi.lds: align the .reloc section; otherwise the
    generated binaries may not validate correctly with Secure Boot.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 01 Jul 2012 21:08:10 -0700

gnu-efi (3.0i-3ubuntu1) maverick; urgency=low

  * Merge from debian unstable.  Remaining changes: LP: #595499
    - Build with -fno-stack-protector.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Thu, 17 Jun 2010 18:20:21 +0530

gnu-efi (3.0i-3) unstable; urgency=low

  * Re-enable optimisation for x64 builds; culprit found & fixed, not related
    to optimization.

  * debian/control:
    + Bump Standards-Version to 3.8.4 (no changes).
    + Add ${misc:Depends}.

 -- Julien BLACHE <jblache@debian.org>  Wed, 05 May 2010 18:18:54 +0200

gnu-efi (3.0i-2ubuntu1) lucid; urgency=low

  * Merge from debian testing. (LP: #488797) Remaining changes:
    - Build with -fno-stack-protector.

 -- Bhavani Shankar <right2bhavi@gmail.com>  Fri, 08 Jan 2010 13:14:01 +0530

gnu-efi (3.0i-2) unstable; urgency=low

  * Disable optimization for x64 builds; it looks very much like there is an
    issue between the call wrapper and optimizations, leading to interesting
    and subtle breakages at runtime.

 -- Julien BLACHE <jblache@debian.org>  Wed, 11 Nov 2009 10:16:08 +0100

gnu-efi (3.0i-1) unstable; urgency=low

  * New upstream release.
    + Support for FreeBSD (closes: #535696).

  * debian/control:
    + Make kfreebsd-amd64 a supported architecture.
    + Build-depend on gcc-multilib on kfreebsd-amd64 too.
  * debian/rules:
    + Add support for both kfreebsd-{i386,amd64}.
    + Install FreeBSD x86_64 linker script on kfreebsd-amd64.
    + Do not install ia64-specific headers on i386/amd64, do not install
      i386/amd64-specific headers on ia64.

 -- Julien BLACHE <jblache@debian.org>  Sat, 12 Sep 2009 11:38:57 +0200

gnu-efi (3.0h-1) unstable; urgency=low

  * Clean up and recover from a broken NMU.

  * debian/control:
    + Bump Standards-Version to 3.8.3 (no changes).
    + Added myself as uploader.

  * gnuefi/elf_ia32_efi.lds:
    + Fix linker script for elf-i386 (closes: #545202).

 -- Julien BLACHE <jblache@debian.org>  Fri, 11 Sep 2009 18:26:22 +0200

gnu-efi (3.0h-0.1) unstable; urgency=low

  * NMU
  * New upstream version.
  * Bump to Standards-Version 3.8.2.
  * Add watch file.
  * Conflict with libc6-i386 (<= 2.9-18).  closes: #533003.

 -- Clint Adams <schizo@debian.org>  Sun, 02 Aug 2009 12:06:40 -0400

gnu-efi (3.0e-3) unstable; urgency=low

  * Non-maintainer upload with maintainer's consent.

  * debian/rules:
    + Move files from /emul/ia32-linux to /usr/lib32 (closes: #533003).

  * debian/control:
    + Bump Standards-Version to 3.8.1 (no changes).

 -- Julien BLACHE <jblache@debian.org>  Wed, 17 Jun 2009 16:41:26 +0200

gnu-efi (3.0e-2) unstable; urgency=low

  * Fixes wrong lib when cross-building, Closes: #482077
  * Fixes x86_64 builds on i386, Closes: #482078
  * Acknowledge NMU, Closes: #473721

 -- Nigel Croxon <nigel.croxon@hp.com>  Wed, 04 Jun 2008 15:11:12 -0600

gnu-efi (3.0e-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix installing below /emul/ia32-linux/usr/lib (not /usr/lib32) on
    AMD64. This closes: bug#473721.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 30 Apr 2008 01:22:35 +0200

gnu-efi (3.0e-1) unstable; urgency=low



=== debian/control ===
Source: gnu-efi
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Baumann <daniel.baumann@progress-technologies.net>
Uploaders: Nigel Croxon <nigel.croxon@hp.com>
Build-Depends:
 debhelper (>= 9), binutils, gcc-multilib [amd64 i386 kfreebsd-amd64]
Standards-Version: 3.9.4
Homepage: http://sourceforge.net/projects/gnu-efi/

Package: gnu-efi
Architecture: amd64 i386 ia64 kfreebsd-amd64
Suggests: elilo
Depends: ${misc:Depends}
Description: Library for developing EFI applications
 GNU toolchain for building applications that can run in the environment
 presented by Intel's EFI (Extensible Firmware Interface). EFI is a firmware
 specification for the "BIOS" on ia64(IPF), IA-32(x86) and x86_64 systems.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	BUILD_ARCH := ia32
else ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	BUILD_ARCH := x86_64
else
	BUILD_ARCH := $(DEB_BUILD_ARCH)
endif

%:
	dh ${@}

override_dh_auto_build:
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	mkdir build-ia32
	$(MAKE) -C build-ia32 -f ../Makefile SRCDIR=.. ARCH=ia32
 endif

ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	mkdir build-x86_64
	$(MAKE) -C build-x86_64 -f ../Makefile SRCDIR=.. ARCH=x86_64 HOSTARCH=ia32
endif

	$(MAKE) ARCH=$(BUILD_ARCH)

override_dh_auto_clean:
	dh_auto_clean

	rm -rf build-*

override_dh_builddeb:
	dh_builddeb -- -Zxz -z9

override_dh_install:
	dh_install

	# gnu-efi files
	mkdir -p debian/gnu-efi/usr/include/efi
	cp -r inc/* debian/gnu-efi/usr/include/efi
	rm debian/gnu-efi/usr/include/efi/Makefile
	rm debian/gnu-efi/usr/include/efi/inc.mak
	rm debian/gnu-efi/usr/include/efi/make.inf
	rm debian/gnu-efi/usr/include/efi/makefile.hdr
	rm debian/gnu-efi/usr/include/efi/protocol/make.inf
	rm debian/gnu-efi/usr/include/efi/protocol/makefile.hdr
	rm debian/gnu-efi/usr/include/efi/protocol/readme.txt
ifeq ($(DEB_BUILD_ARCH),ia64)
	rm -rf debian/gnu-efi/usr/include/efi/ia32
	rm -rf debian/gnu-efi/usr/include/efi/x84_64
else
	rm -rf debian/gnu-efi/usr/include/efi/ia64
endif
	mkdir -p debian/gnu-efi/usr/lib
	cp gnuefi/*.a debian/gnu-efi/usr/lib
ifeq ($(DEB_BUILD_ARCH),kfreebsd-amd64)
	cp gnuefi/elf_$(BUILD_ARCH)_fbsd_efi.lds debian/gnu-efi/usr/lib
else
	cp gnuefi/elf_$(BUILD_ARCH)_efi.lds debian/gnu-efi/usr/lib
endif
	cp gnuefi/crt0-efi-$(BUILD_ARCH).o debian/gnu-efi/usr/lib
	cp lib/*.a debian/gnu-efi/usr/lib

ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	mkdir -p debian/gnu-efi/usr/lib32
	cp build-ia32/gnuefi/*.a debian/gnu-efi/usr/lib32
	cp gnuefi/elf_ia32_efi.lds debian/gnu-efi/usr/lib32
	cp build-ia32/gnuefi/crt0-efi-ia32.o debian/gnu-efi/usr/lib32
	cp build-ia32/lib/*.a debian/gnu-efi/usr/lib32
endif

ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	mkdir -p debian/gnu-efi/usr/lib64
	cp build-x86_64/gnuefi/*.a debian/gnu-efi/usr/lib64
ifeq ($(DEB_BUILD_ARCH),kfreebsd-i386)
	cp gnuefi/elf_x86_64_fbsd_efi.lds debian/gnu-efi/usr/lib64
else
	cp gnuefi/elf_x86_64_efi.lds debian/gnu-efi/usr/lib64
endif
	cp build-x86_64/gnuefi/crt0-efi-x86_64.o debian/gnu-efi/usr/lib64
	cp build-x86_64/lib/*.a debian/gnu-efi/usr/lib64
endif

## gnu-efi 3.0u+debian

=== Makefile ===
--- 
+++ 
@@ -45,6 +45,32 @@
 
 all:	check_gcc $(SUBDIRS)
 
+mkvars:
+	@echo AR=$(AR)
+	@echo ARCH=$(ARCH)
+	@echo ARCH3264=$(ARCH3264)
+	@echo AS=$(AS)
+	@echo ASFLAGS=$(ASFLAGS)
+	@echo CC=$(CC)
+	@echo CFLAGS=$(CFLAGS)
+	@echo CPPFLAGS=$(CPPFLAGS)
+	@echo GCCMINOR=$(GCCMINOR)
+	@echo GCCNEWENOUGH=$(GCCNEWENOUGH)
+	@echo GCCVERSION=$(GCCVERSION)
+	@echo HOSTARCH=$(HOSTARCH)
+	@echo INCDIR=$(INCDIR)
+	@echo INSTALL=$(INSTALL)
+	@echo INSTALLROOT=$(INSTALLROOT)
+	@echo LD=$(LD)
+	@echo LDFLAGS=$(LDFLAGS)
+	@echo LIBDIR=$(LIBDIR)
+	@echo OBJCOPY=$(OBJCOPY)
+	@echo OS=$(OS)
+	@echo prefix=$(prefix)
+	@echo PREFIX=$(PREFIX)
+	@echo RANLIB=$(RANLIB)
+	@echo TOPDIR=$(TOPDIR)
+
 $(SUBDIRS):
 	mkdir -p $@
 	$(MAKE) -C $@ -f $(SRCDIR)/../$@/Makefile SRCDIR=$(SRCDIR)/../$@ ARCH=$(ARCH)

=== apps/Makefile ===
--- 
+++ 
@@ -48,17 +48,15 @@
 CRTOBJS		= ../gnuefi/crt0-efi-$(ARCH).o
 
 LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_efi.lds
-ifeq ($(ARCH),x86_64)
- ifneq (,$(findstring FreeBSD,$(OS)))
+ifneq (,$(findstring FreeBSD,$(OS)))
 LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_fbsd_efi.lds
- endif
 endif
 
 LDFLAGS		+= -T $(LDSCRIPT) -shared -Bsymbolic -L../lib -L../gnuefi $(CRTOBJS)
 LOADLIBES	= -lefi -lgnuefi $(shell $(CC) $(ARCH3264) -print-libgcc-file-name)
 FORMAT		= efi-app-$(ARCH)
 
-TARGETS = t.efi t2.efi t3.efi t4.efi t5.efi t6.efi printenv.efi t7.efi tcc.efi
+TARGETS = t.efi t2.efi t3.efi t4.efi t5.efi t6.efi printenv.efi t7.efi tcc.efi modelist.efi route80h.efi
 
 all:	$(TARGETS)

=== gnuefi/Makefile ===
--- 
+++ 
@@ -51,7 +51,7 @@
 
 all:	$(TARGETS)
 
-libgnuefi.a: libgnuefi.a($(OBJS))
+libgnuefi.a: $(patsubst %,libgnuefi.a(%),$(OBJS))
 
 clean:
 	rm -f $(TARGETS) *~ *.o $(OBJS)

=== inc/Makefile ===
SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR=$(TOPDIR)/..

all:

clean:

install:
	mkdir -p $(INSTALLROOT)$(PREFIX)/include/efi
	mkdir -p $(INSTALLROOT)$(PREFIX)/include/efi/protocol
	mkdir -p $(INSTALLROOT)$(PREFIX)/include/efi/$(ARCH)
	$(INSTALL) -m 644 *.h $(INSTALLROOT)$(PREFIX)/include/efi
	$(INSTALL) -m 644 protocol/*.h $(INSTALLROOT)$(PREFIX)/include/efi/protocol
	$(INSTALL) -m 644 $(ARCH)/*.h $(INSTALLROOT)$(PREFIX)/include/efi/$(ARCH)
ifeq ($(ARCH),ia64)
	mkdir -p $(INSTALLROOT)$(PREFIX)/include/efi/protocol/ia64
	$(INSTALL) -m 644 protocol/ia64/*.h $(INSTALLROOT)$(PREFIX)/include/efi/protocol/ia64
endif

include $(SRCDIR)/../Make.rules

=== lib/Makefile ===
--- 
+++ 
@@ -66,7 +66,7 @@
 libsubdirs:
 	for sdir in $(SUBDIRS); do mkdir -p $$sdir; done
 
-libefi.a: libefi.a($(OBJS))
+libefi.a: $(patsubst %,libefi.a(%),$(OBJS))
 
 clean:
 	rm -f libefi.a *~ $(OBJS) */*.o

=== debian/changelog ===
gnu-efi (3.0u+debian-4ubuntu1) utopic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/gcc46-compatibility: don't break with old compilers
      and -DGNU_EFI_USE_MS_ABI.
  * Dropped changes, included in Debian:
    - pass architecture arguments when building the x86_64 code on i386

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 24 Apr 2014 19:45:05 -0700

gnu-efi (3.0u+debian-4) unstable; urgency=low

  * Updating to standards version 3.9.5.
  * Building with dh --parallel.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Mon, 31 Mar 2014 19:56:19 +0200

gnu-efi (3.0u+debian-3) experimental; urgency=low

  * Updating vcs fields.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Thu, 17 Oct 2013 10:06:18 +0200

gnu-efi (3.0u+debian-2) experimental; urgency=low

  [ Daniel Baumann ]
  * Adding vcs fields.

  [ Steve Langasek ]
  * Passing architecture arguments when building the x86_64 code on i386;
    otherwise the upstream build system wrongly assumes that if uname says
    x86_64, it doesn't have to pass -m64 to the compiler.

  [ Daniel Baumann ]
  * Wrapping control fields.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Wed, 17 Jul 2013 10:34:32 +0200

gnu-efi (3.0u+debian-1ubuntu2) saucy; urgency=low

  * debian/patches/gcc46-compatibility: don't break with old compilers
    and -DGNU_EFI_USE_MS_ABI.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 24 Sep 2013 06:41:55 +0000

gnu-efi (3.0u+debian-1ubuntu1) saucy; urgency=low

  * Merge from Debian experimental, remaining changes:
    - pass architecture arguments when building the x86_64 code on i386
  * Dropped changes, included upstream:
    - build with -fno-stack-protector.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 02 Jul 2013 05:50:05 +0000

gnu-efi (3.0u+debian-1) experimental; urgency=low

  * Merging upstream version 3.0u+debian (Closes: #712639).
  * Dropping no-stack-protector.patch, included upstream.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Tue, 18 Jun 2013 10:38:29 +0200

gnu-efi (3.0t+debian-2) experimental; urgency=low

  * Dropping suggests on elilo.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Sun, 09 Jun 2013 10:04:12 +0200

gnu-efi (3.0t+debian-1) experimental; urgency=low

  * Merging upstream version 3.0t+debian.
  * Updating year in copyright file.
  * Refreshing no-stack-protector.patch.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Wed, 13 Mar 2013 18:22:37 +0100

gnu-efi (3.0s+debian-3) unstable; urgency=low

  * Removing all references to my old email address.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Sun, 10 Mar 2013 20:46:34 +0100

gnu-efi (3.0s+debian-2) unstable; urgency=low

  * Adding no-stack-protector.patch from Colin Watson
    <cjwatson@ubuntu.com> to make other packages being able to link
    against gnu-efi.
  * Dropping dpkg-source compression levels.
  * Adding dpkg-source local-options.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Wed, 20 Feb 2013 16:41:16 +0100

=== debian/control ===
Source: gnu-efi
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Baumann <mail@daniel-baumann.ch>
Uploaders: Nigel Croxon <nigel.croxon@hp.com>
Build-Depends:
 debhelper (>= 9),
 binutils,
 gcc-multilib [amd64 i386 kfreebsd-amd64],
Standards-Version: 3.9.5
Homepage: http://sourceforge.net/projects/gnu-efi/
Vcs-Browser: http://daniel-baumann.ch/gitweb/?p=debian/packages/gnu-efi.git
Vcs-Git: git://daniel-baumann.ch/git/debian/packages/gnu-efi.git

Package: gnu-efi
Architecture: amd64 i386 ia64 kfreebsd-amd64
Depends: ${misc:Depends}
Description: Library for developing EFI applications
 GNU toolchain for building applications that can run in the environment
 presented by Intel's EFI (Extensible Firmware Interface). EFI is a firmware
 specification for the "BIOS" on ia64(IPF), IA-32(x86) and x86_64 systems.

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 endif
 
 %:
-	dh ${@}
+	dh ${@} --parallel
 
 override_dh_auto_build:
 ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
@@ -32,7 +32,7 @@
 	rm -rf build-*
 
 override_dh_builddeb:
-	dh_builddeb -- -Zxz -z9
+	dh_builddeb -- -Zxz
 
 override_dh_install:
 	dh_install

## gnu-efi 3.0v

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 #    SUCH DAMAGE.
 #
 
-SRCDIR = .
+SRCDIR = $(shell pwd)
 
 VPATH = $(SRCDIR)
 
@@ -69,18 +69,25 @@
 	@echo prefix=$(prefix)
 	@echo PREFIX=$(PREFIX)
 	@echo RANLIB=$(RANLIB)
+	@echo SRCDIR=$(SRCDIR)
 	@echo TOPDIR=$(TOPDIR)
 
 $(SUBDIRS):
 	mkdir -p $@
-	$(MAKE) -C $@ -f $(SRCDIR)/../$@/Makefile SRCDIR=$(SRCDIR)/../$@ ARCH=$(ARCH)
+	$(MAKE) -C $@ -f $(SRCDIR)/$@/Makefile SRCDIR=$(SRCDIR)/$@ ARCH=$(ARCH)
 
 clean:
 	rm -f *~
-	@for d in $(SUBDIRS); do $(MAKE) -C $$d clean; done
+	@for d in $(SUBDIRS); do \
+		if [ -d $$d ]; then \
+			$(MAKE) -C $$d -f $(SRCDIR)/$$d/Makefile SRCDIR=$(SRCDIR)/$$d clean; \
+		fi; \
+	done
 
 install:
-	@for d in $(SUBDIRS); do $(MAKE) -C $$d install; done
+	@for d in $(SUBDIRS); do \
+		mkdir -p $$d; \
+		$(MAKE) -C $$d -f $(SRCDIR)/$$d/Makefile SRCDIR=$(SRCDIR)/$$d install; done
 
 .PHONY:	$(SUBDIRS) clean depend

=== gnuefi/Makefile ===
--- 
+++ 
@@ -43,11 +43,24 @@
 TOPDIR = $(SRCDIR)/..
 
 CDIR=$(TOPDIR)/..
-FILES	= reloc_$(ARCH) setjmp_$(ARCH)
+FILES	= reloc_$(ARCH)  
 
 OBJS	= $(FILES:%=%.o)
 
 TARGETS	= crt0-efi-$(ARCH).o libgnuefi.a
+
+INSTALLTARGETS = $(TARGETS)
+ifneq (,$(findstring FreeBSD,$(OS)))
+ ifeq ($(ARCH),x86_64)
+  INSTALLTARGETS += elf_$(ARCH)_fbsd_efi.lds
+ else
+  INSTALLTARGETS += elf_$(ARCH)_efi.lds
+ endif
+else
+  INSTALLTARGETS += elf_$(ARCH)_efi.lds
+endif
+
+LIBDIRINSTALL = $(INSTALLROOT)/$(LIBDIR)
 
 all:	$(TARGETS)
 
@@ -56,17 +69,14 @@
 clean:
 	rm -f $(TARGETS) *~ *.o $(OBJS)
 
-install:
-	mkdir -p $(INSTALLROOT)/$(LIBDIR)
-	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)/$(LIBDIR)
-ifneq (,$(findstring FreeBSD,$(OS)))
- ifeq ($(ARCH),x86_64)
-	$(INSTALL) -m 644 elf_$(ARCH)_fbsd_efi.lds $(INSTALLROOT)/$(LIBDIR)
- else
-	$(INSTALL) -m 644 elf_$(ARCH)_efi.lds $(INSTALLROOT)/$(LIBDIR)
- endif
-else
-	$(INSTALL) -m 644 elf_$(ARCH)_efi.lds $(INSTALLROOT)/$(LIBDIR)
-endif
+$(LIBDIRINSTALL):
+	mkdir -p $@
+
+.SECONDEXPANSION:
+
+$(LIBDIRINSTALL)/%: % | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(dir $@)
+
+install: $(addprefix $(LIBDIRINSTALL)/,$(INSTALLTARGETS))
 
 include $(SRCDIR)/../Make.rules

=== inc/Makefile ===
SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR=$(TOPDIR)/..

INCDIRINSTALL = $(INSTALLROOT)$(PREFIX)/include/efi

SRCHEADERS = $(wildcard $(SRCDIR)/*.h) \
             $(wildcard $(SRCDIR)/protocol/*.h) \
             $(wildcard $(SRCDIR)/$(ARCH)/*.h)
ifeq ($(ARCH),ia64)
 SRCHEADERS += $(wildcard $(SRCDIR)/protocol/$(ARCH)/*.h)
endif

HEADERS = $(patsubst $(SRCDIR)/%,%,$(SRCHEADERS))

all:

clean:

$(INCDIRINSTALL) \
$(INCDIRINSTALL)/protocol \
$(INCDIRINSTALL)/$(ARCH) \
$(INCDIRINSTALL)/protocol/$(ARCH):
	mkdir -p $@

.SECONDEXPANSION:

$(INCDIRINSTALL)/%.h: %.h | $$(dir $$@)
	$(INSTALL) -m 644 $< $(dir $@)

install: $(addprefix $(INCDIRINSTALL)/,$(HEADERS))

include $(SRCDIR)/../Make.rules

=== lib/Makefile ===
--- 
+++ 
@@ -43,7 +43,7 @@
 TOPDIR = $(SRCDIR)/..
 
 CDIR = $(TOPDIR)/..
-FILES = boxdraw smbios console crc data debug dpath  \
+FILES = ParseCmdLine boxdraw smbios console crc data debug dpath  \
         error event guid hand hw init lock   \
         misc print sread str \
 	runtime/rtlock runtime/efirtlib runtime/rtstr runtime/vm runtime/rtdata  \
@@ -61,8 +61,11 @@
 
 SUBDIRS = ia32 x86_64 ia64 runtime
 
+LIBDIRINSTALL = $(INSTALLROOT)/$(LIBDIR)
+
 all: libsubdirs libefi.a
 
+.PHONY: libsubdirs
 libsubdirs:
 	for sdir in $(SUBDIRS); do mkdir -p $$sdir; done
 
@@ -71,9 +74,13 @@
 clean:
 	rm -f libefi.a *~ $(OBJS) */*.o
 
-install: libefi.a
-	mkdir -p $(INSTALLROOT)/$(LIBDIR)
-	$(INSTALL) -m 644 libefi.a $(INSTALLROOT)/$(LIBDIR)
+$(LIBDIRINSTALL):
+	mkdir -p $@
+
+$(LIBDIRINSTALL)/libefi.a: libefi.a | $(LIBDIRINSTALL)
+	$(INSTALL) -m 644 $< $(dir $@)
+
+install: $(LIBDIRINSTALL)/libefi.a
 
 include $(SRCDIR)/../Make.rules

=== debian/changelog ===
gnu-efi (3.0v-5) unstable; urgency=medium

  * inc/efistdarg.h: Use gcc builtins instead of stubs
    - The last upload of gnu-efi caused things to compile, but severely
      broke them.

 -- Julian Andres Klode <jak@debian.org>  Mon, 21 Jul 2014 13:20:23 +0200

gnu-efi (3.0v-4) unstable; urgency=medium

  * Take over maintenance
  * Add git information and git-buildpackage configuration
  * Use gbp pq for maintaining the patch queue
  * inc/efistdarg.h: Stub out va_copy (Closes: #753682)

 -- Julian Andres Klode <jak@debian.org>  Sat, 19 Jul 2014 14:02:06 +0200

gnu-efi (3.0v-3) unstable; urgency=low

  * Stepping down from maintainers, no interest anymore since syslinux uses
    its own copy of gnu-efi that is bundled and sort-of impossible to patch
    out.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Wed, 16 Jul 2014 21:49:17 +0200

gnu-efi (3.0v-2) unstable; urgency=low

  * Temporarily build without stdarg.h in efistdarg.h (Closes: #747158).

 -- Daniel Baumann <mail@daniel-baumann.ch>  Tue, 06 May 2014 06:15:54 +0200

gnu-efi (3.0v-1) unstable; urgency=low

  * Merging upstream version 3.0v.
  * Updating year in copyright file.
  * Updating make calls in rules for new upstream release.

 -- Daniel Baumann <mail@daniel-baumann.ch>  Sat, 05 Apr 2014 13:03:14 +0200

=== debian/control ===
Source: gnu-efi
Section: devel
Priority: optional
Maintainer: Julian Andres Klode <jak@debian.org>
Uploaders: Nigel Croxon <nigel.croxon@hp.com>
Build-Depends:
 debhelper (>= 9),
 binutils,
 gcc-multilib [amd64 i386 kfreebsd-amd64],
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/collab-maint/gnu-efi.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/gnu-efi.git
Homepage: http://sourceforge.net/projects/gnu-efi/

Package: gnu-efi
Architecture: amd64 i386 ia64 kfreebsd-amd64
Depends: ${misc:Depends}
Description: Library for developing EFI applications
 GNU toolchain for building applications that can run in the environment
 presented by Intel's EFI (Extensible Firmware Interface). EFI is a firmware
 specification for the "BIOS" on ia64(IPF), IA-32(x86) and x86_64 systems.

=== debian/rules ===
--- 
+++ 
@@ -16,12 +16,12 @@
 override_dh_auto_build:
 ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
 	mkdir build-ia32
-	$(MAKE) -C build-ia32 -f ../Makefile SRCDIR=.. ARCH=ia32
+	$(MAKE) -C build-ia32 -f ../Makefile SRCDIR=$(CURDIR) ARCH=ia32
  endif
 
 ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
 	mkdir build-x86_64
-	$(MAKE) -C build-x86_64 -f ../Makefile SRCDIR=.. ARCH=x86_64 HOSTARCH=ia32
+	$(MAKE) -C build-x86_64 -f ../Makefile SRCDIR=$(CURDIR) ARCH=x86_64 HOSTARCH=ia32
 endif
 
 	$(MAKE) ARCH=$(BUILD_ARCH)
